<template>
  <div class="mt-5">
    <div class="container">
      <div class="row">
        <!-- Sidebar -->
        <div class="col-md-4 col-lg-3">
          <!-- Filters -->
          <div class="card border-0 rounded-20 mb-3">
            <div class="border-bottom p-3">
              <p class="h5 mb-0">فیلترهای اعمال شده</p>
            </div>
            <div class="card-body px-3 pb-2 pt-3">
              <template v-if="selectedFilters && selectedFilters.namedTags">
                <p
                  v-for="selectedFilter in selectedFilters.namedTags"
                  :key="selectedFilter.id"
                  class="
                    d-inline-block
                    bg-dark1
                    rounded-pill
                    py-1
                    px-2
                    mb-2
                    me-1
                  "
                >
                  {{ selectedFilter.title }}
                  <svg
                    class="cursor-pointer ms-1"
                    width="16"
                    height="16"
                    viewBox="0 0 16 16"
                    fill="none"
                    xmlns="http://www.w3.org/2000/svg"
                    @click="deleteFilter(selectedFilter.id)"
                  >
                    <path
                      fill-rule="evenodd"
                      clip-rule="evenodd"
                      d="M8 0.5C3.8525 0.5 0.5 3.8525 0.5 8C0.5 12.1475 3.8525 15.5 8 15.5C12.1475 15.5 15.5 12.1475 15.5 8C15.5 3.8525 12.1475 0.5 8 0.5ZM11.75 10.6925L10.6925 11.75L8 9.0575L5.3075 11.75L4.25 10.6925L6.9425 8L4.25 5.3075L5.3075 4.25L8 6.9425L10.6925 4.25L11.75 5.3075L9.0575 8L11.75 10.6925Z"
                      fill="#7D7D7D"
                    />
                  </svg>
                </p>
              </template>
              <template v-else>
                <p class="mb-2 text-center">هیچ فیلتری وجود ندارد</p>
              </template>
            </div>
          </div>
          <!-- Accurate search -->
          <div v-if="$route.query.s" class="card border-0 rounded-20 mb-3">
            <div class="border-bottom p-3">
              <p class="h5 mb-0">جستجوی دقیق تر</p>
            </div>
            <div
              class="card-body px-3 pb-2 pt-3"
              style="height: 210px; overflow: auto"
            >
              <label
                v-for="facet in facets.namedTags"
                :key="facet.id"
                class="checkbox-wrapper"
              >
                <input
                  v-model="accurateSearch"
                  :value="facet.id"
                  type="checkbox"
                  @change="onNamedTags"
                />
                <span class="checkmark"></span>
                {{ facet.title }}
                <span>({{ facet.count }})</span>
              </label>
            </div>
          </div>
          <!-- Free delivery -->
          <div class="card border-0 rounded-20 mb-3">
            <div class="p-3">
              <div class="switch-checkbox-wrapper">
                <input
                  id="freeShipping"
                  type="checkbox"
                  class="switch"
                  name="freeShipping"
                  :checked="$route.query.freeShipping"
                  @change="onChangeSwitch('freeShipping', $event)"
                />
                <label class="cursor-pointer h5 ms-2 mb-0" for="freeShipping">
                  ارسال رایگان
                </label>
              </div>
            </div>
          </div>
          <!-- Stock -->
          <div class="card border-0 rounded-20 mb-3">
            <div class="p-3">
              <div class="switch-checkbox-wrapper">
                <input
                  id="isExists"
                  type="checkbox"
                  class="switch"
                  name="isExists"
                  :checked="$route.query.isExists"
                  @change="onChangeSwitch('isExists', $event)"
                />
                <label class="cursor-pointer h5 ms-2 mb-0" for="isExists">
                  فقط کالاهای موجود
                </label>
              </div>
            </div>
          </div>
          <!-- Ready to send -->
          <div class="card border-0 rounded-20 mb-3">
            <div class="p-3">
              <div class="switch-checkbox-wrapper">
                <input
                  id="isReady"
                  type="checkbox"
                  class="switch"
                  name="isReady"
                  :checked="$route.query.isReady"
                  @change="onChangeSwitch('isReady', $event)"
                />
                <label class="cursor-pointer h5 ms-2 mb-0" for="isReady">
                  آماده ارسال
                </label>
              </div>
            </div>
          </div>
          <!-- Discounts -->
          <div class="card border-0 rounded-20 mb-3">
            <div class="p-3">
              <div class="switch-checkbox-wrapper">
                <input
                  id="hasDiscount"
                  type="checkbox"
                  class="switch"
                  name="hasDiscount"
                  :checked="$route.query.hasDiscount"
                  @change="onChangeSwitch('hasDiscount', $event)"
                />
                <label class="cursor-pointer h5 ms-2 mb-0" for="hasDiscount">
                  تخفیف دارها
                </label>
              </div>
            </div>
          </div>
        </div>
        <!-- Content -->
        <div class="col-md-8 col-lg-9">
          <!-- Sort -->
          <div
            class="
              d-xl-flex
              align-items-center
              bg-white
              rounded-10
              px-3
              py-2
              mb-4
            "
          >
            <p class="mb-xl-0">نمایش براساس:</p>
            <ul class="nav ps-0 ps-lg-3">
              <li
                v-for="(available_sort, index) in availableSorts"
                :key="index"
              >
                <span
                  class="
                    d-block
                    border
                    rounded-pill
                    cursor-pointer
                    py-1
                    px-3
                    me-1
                    mb-1
                    me-lg-3
                    mb-xl-0
                  "
                  :class="sortActiveClass(available_sort)"
                  @click="onSort(available_sort)"
                  >{{ available_sort.name }}</span
                >
              </li>
            </ul>
          </div>
          <!-- Products -->
          <div class="products">
            <div class="row g-3 position-relative">
              <ProductList
                v-for="(product, index) in products"
                :key="index"
                :product="product"
              />
              <!-- Loading -->
              <!-- <div class="col-12 text-center my-5">
                <svg
                  class="spinner-border w-auto h-auto border-0"
                  width="50"
                  height="50"
                  viewBox="0 0 50 50"
                  fill="none"
                  xmlns="http://www.w3.org/2000/svg"
                >
                  <path
                    d="M45.8333 25C45.8333 36.506 36.5059 45.8334 25 45.8334C13.494 45.8334 4.16664 36.506 4.16664 25C4.16664 13.4941 13.494 4.16672 25 4.16672C36.5059 4.16672 45.8333 13.4941 45.8333 25ZM11.4583 25C11.4583 32.4789 17.5211 38.5417 25 38.5417C32.4788 38.5417 38.5416 32.4789 38.5416 25C38.5416 17.5212 32.4788 11.4584 25 11.4584C17.5211 11.4584 11.4583 17.5212 11.4583 25Z"
                    fill="#DB3755"
                    fill-opacity="0.07"
                  />
                  <path
                    d="M25 4.16662C27.7358 4.16662 30.4449 4.70549 32.9725 5.75246C35.5002 6.79943 37.7968 8.33401 39.7314 10.2686C41.6659 12.2031 43.2005 14.4998 44.2475 17.0274C45.2944 19.555 45.8333 22.2641 45.8333 24.9999L38.5416 24.9999C38.5416 23.2216 38.1914 21.4607 37.5108 19.8178C36.8303 18.1748 35.8328 16.682 34.5754 15.4245C33.3179 14.1671 31.8251 13.1696 30.1821 12.4891C28.5392 11.8086 26.7783 11.4583 25 11.4583L25 4.16662Z"
                    fill="#DB3755"
                  />
                </svg>
              </div> -->
              <client-only>
                <infinite-loading
                  spinner="spiral"
                  @infinite="infiniteScroll"
                ></infinite-loading>
              </client-only>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ProductList from '@/components/Product/ProductList'

export default {
  components: {
    ProductList,
  },
  layout: 'default',
  data() {
    return {
      products: [],
      facets: [],
      selectedFilters: [],
      accurateSearch: [],
      from: 0,
      size: 12,
      sort: null,
      availableSorts: [
        {
          name: 'مرتبط‌ترین',
          sort: null,
        },
        {
          name: 'پرفروش‌ترین',
          sort: {
            field: 'salesCount',
            dir: 'desc',
          },
        },
        {
          name: 'بیشترین تخفیف',
          sort: {
            field: 'maxDiscount',
            dir: 'desc',
          },
        },
        {
          name: 'ارزان‌ترین',
          sort: {
            field: 'price',
            dir: 'asc',
          },
        },
        {
          name: 'گران‌ترین',
          sort: {
            field: 'price',
            dir: 'desc',
          },
        },
        {
          name: 'جدیدترین',
          sort: {
            field: 'id',
            dir: 'desc',
          },
        },
      ],
    }
  },
  async fetch() {
    // Get namedTags of url and set to accurateSearch
    const { namedTags } = this.$route.query || undefined
    if (Array.isArray(namedTags)) {
      this.accurateSearch = namedTags[0]
    } else if (namedTags !== undefined) {
      this.accurateSearch = namedTags.split(',').map((x) => +x)
    }

    // Get sorted of url and set to sort
    const sort = this.$route.query.sort || null
    if (sort) {
      this.sort = this.availableSorts.find((x) => x.name === sort).sort
    }

    const payload = {
      q: this.$route.query.s,
      facets: ['namedTags'],
      productAds: false,
      sort: this.sort,
      from: 0,
      size: this.size,
      filters: {
        freeShipping: this.$route.query.freeShipping,
        isExists: this.$route.query.isExists,
        isReady: this.$route.query.isReady,
        hasDiscount: this.$route.query.hasDiscount,
        namedTags: [...this.accurateSearch],
      },
    }
    await this.$axios.$post('/product/search', payload).then((res) => {
      this.products = res.products
      this.facets = res.facets
      this.selectedFilters = res.selectedFilters
    })
  },

  methods: {
    sortActiveClass(sortItem) {
      return this.$route.query.sort === sortItem.name
        ? 'text-success-1 border-success-1'
        : ''
    },

    onNamedTags() {
      if (Array.isArray(this.accurateSearch) && this.accurateSearch.length) {
        this.$router.push({
          query: {
            ...this.$route.query,
            namedTags: [this.accurateSearch],
          },
        })
      } else {
        this.$router.push({
          query: {
            ...this.$route.query,
            namedTags: undefined,
          },
        })
      }
    },

    deleteFilter(id) {
      this.accurateSearch = this.accurateSearch.filter((item) => item !== id)
      this.onNamedTags()
    },

    onChangeSwitch(params, event) {
      const value = event.target.checked ? true : undefined
      this.$router.push({
        query: { ...this.$route.query, [params]: value },
      })
    },

    onSort(item) {
      this.$router.push({
        query: { ...this.$route.query, sort: item.name },
      })
    },

    infiniteScroll($state) {
      const payload = {
        q: this.$route.query.s,
        facets: ['namedTags'],
        productAds: false,
        sort: this.sort,
        from: this.from === 0 ? 12 : this.from,
        size: this.size,
        filters: {
          freeShipping: this.$route.query.freeShipping,
          isExists: this.$route.query.isExists,
          isReady: this.$route.query.isReady,
          hasDiscount: this.$route.query.hasDiscount,
          namedTags: [...this.accurateSearch],
        },
      }
      this.$axios.$post('/product/search', payload).then((res) => {
        this.from += 12
        this.products.push(...res.products)
        if (this.from < res.meta.count) {
          $state.loaded()
        } else {
          $state.complete()
        }
      })
    },
  },
}
</script>

<style scoped>
</style>